Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QuasmonString.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QuasmonString.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QuasmonString.cc	(revision 1055)
@@ -28,10 +28,16 @@
 //
 //
-// $Id: G4QuasmonString.cc,v 1.7 2006/11/27 10:44:55 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QuasmonString.cc,v 1.8 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QuasmonString ----------------
 //             by Mikhail Kossov, August 2000.
 //  class for Hadron-Hadron String Interaction used by the CHIPS Model
+// -------------------------------------------------------------------
+// Short description: The Quark-Gluon String can fragment in hadrons
+// (QGS), small hadronic clusters (HERWIG) or in unlimited in mass
+// Quasmons, defined by the G4QPartonPair. This class is made to
+// simulate the string fragmentation in Quasmons, which hadronize in
+// vacuuum or in nuclear environment.
 // -------------------------------------------------------------------
  
@@ -71,5 +77,5 @@
   theWorld= G4QCHIPSWorld::Get();             // Get a pointer to the CHIPS World
 #ifdef debug
-  G4cout<<"-->G4QString::Constr:pPDG="<<projHadron.GetPDGCode()<<",tPDG="<<targPDG<<G4endl;
+  G4cout<<"-->G4QuasStr::Constr:pPDG="<<projHadron.GetPDGCode()<<",tPDG="<<targPDG<<G4endl;
 #endif
   // Target initialization
@@ -84,5 +90,5 @@
   // Projectile initialization
   theProj4Mom = projHadron.Get4Momentum();
-		G4ThreeVector projBoost = theProj4Mom.boostVector(); // Projectile BoostVector to LS
+  G4ThreeVector projBoost = theProj4Mom.boostVector(); // Projectile BoostVector to LS
   G4ThreeVector projRBoost= -projBoost;       // Projevtile Boost vector to projectile CMS
   G4QPDGCode projQPDG(projHadron.GetPDGCode());
@@ -97,18 +103,18 @@
   G4double tM2 = tM*tM;
   G4double dM2 = fabs(pM2-projM2);
-  if(dM2>1.) G4cout<<"-Wor-G4QS::Constr:dM2="<<dM2<<",M2="<<projM2<<",LVM2="<<pM2<<G4endl;
+  if(dM2>1.) G4cout<<"-Wor-G4QuStr::Cons:dM2="<<dM2<<",M2="<<projM2<<",LVM2="<<pM2<<G4endl;
   G4double pM=sqrt(pM2);                     // @@ do we need pM ? @@ (in print)
 
   // === Print out of the input information at Creation time & tot 4-mom Calculation ======
 #ifdef pdebug
-  G4cout<<"G4QS::Cons:PQC="<<theProjQC<<",TQC="<<theTargQC<<",P4Mom="<<theProj4Mom<<
-				theProj4Mom.m2()<<theProj4Mom.m()<<G4endl;
-  G4cout<<"G4QStr::Constr: tC="<<totCharge<<",tB="<<totBaryNum<<",tot4M="<<tot4Mom<<G4endl;
+  G4cout<<"G4QuaString::Cons:PQC="<<theProjQC<<",TQC="<<theTargQC<<",P4Mom="<<theProj4Mom<<
+    theProj4Mom.m2()<<theProj4Mom.m()<<G4endl;
+  G4cout<<"G4QuaString::C: tC="<<totCharge<<",tB="<<totBaryNum<<",tot4M="<<tot4Mom<<G4endl;
 #endif
   //G4int nP=theWorld->GetQPEntries();       // A#of init'ed particles in CHIPS World (@@?)
   //G4int nCl=nP-90;                          // A#of init'ed clusters in CHIPS World (@@?)
-		//#ifdef pdebug
+  //#ifdef pdebug
   //G4cout<<"G4QS:Const:Before QEX:n="<<nP<<G4endl;
-		//#endif
+  //#endif
   // @@@@@@ ===> Here the Quark Exchange Quasmon Creation must be added <=== @@@@@@
   // @@ --- old ---
@@ -136,5 +142,5 @@
   // @@ --- end ---
 #ifdef pdebug
-  G4cout<<"G4QStr::Constr: nP="<<nQProj<<", nT="<<nQTarg<<G4endl;
+  G4cout<<"G4QuasmonString::Constr: nP="<<nQProj<<", nT="<<nQTarg<<G4endl;
 #endif
   // @@ Now projectile can be only meson or baryon @@ -- @@ Improve for clusters @@ --
@@ -143,7 +149,7 @@
   G4bool FreeFraF=false;                     // Prototype of the free exchange Flag
   if(G4UniformRand()<FreeFra) FreeFraF=true; // Confirm the free exchange
-  if(nQProj<2)  G4cout<<"***G4QSt::Constr: nQProj="<<nQProj<<"<2 ***FatalError***"<<G4endl;
-		else if(nQProj>2)                          // ---> Baryon case (clusters are not implem.)
-		{
+  if(nQProj<2)  G4cout<<"***G4QuaStr::Con: nQProj="<<nQProj<<"<2 ***FatalError***"<<G4endl;
+  else if(nQProj>2)                          // ---> Baryon case (clusters are not implem.)
+  {
     //if(nQProj>3)G4cout<<"-Wor-G4QS::Const:nQProj="<<nQProj<<">3 is not implem'd"<<G4endl;
     G4double xP=0.;
@@ -153,5 +159,5 @@
       xP=RandomizeMomFractionString(nQProj);
       theWeight*=pow(xP,interc);
-      G4cout<<"************G4QS::C: string xP="<<xP<<G4endl;
+      G4cout<<"************G4QuasmonString::Constr: string xP="<<xP<<G4endl;
     }
     rPMass = sqrt(pM2*(1.-xP));              // Residual Projectile mass
@@ -166,7 +172,7 @@
   if(tmpBl) projFl=true;                     // Proj decay is OK
   //if(projHadron.DecayIn2(pq4Mom,pr4Mom)) projFl=true;
-  else G4cout<<"**Worning**G4QuasmonString::Constr:ProjDecIn2 rpM="<<rPMass<<", pM="<<pM<<G4endl;
-#ifdef pdebug
-  G4cout<<"G4QStr::Con:"<<projFl<<" split PROJ in R4M="<<pr4Mom<<" & Q4M="<<pq4Mom<<G4endl;
+  else G4cout<<"**Warning**G4QuasmonString::C:ProjDecIn2 rpM="<<rPMass<<",pM="<<pM<<G4endl;
+#ifdef pdebug
+  G4cout<<"G4QuaStr::C:"<<projFl<<" split PROJ in R4M="<<pr4Mom<<" & Q4M="<<pq4Mom<<G4endl;
 #endif
   G4LorentzVector tq4Mom(0.,0.,0.,0.);       // Prototype of LV of quark of the target  
@@ -179,15 +185,15 @@
     xT=RandomizeMomFractionString(nQTarg);
     theWeight*=pow(xT,interc);
-    G4cout<<"************G4QS::C: string xT="<<xT<<G4endl;
+    G4cout<<"************G4QuaString::Constr: string xT="<<xT<<G4endl;
   }
   G4double rTMass = sqrt(tM2*(1.-xT));       // Residual Target mass
 #ifdef pdebug
-  G4cout<<"G4QS::C: nQTarg="<<nQTarg<<", xProj="<<xT<<", rTMass="<<rTMass<<G4endl;
+  G4cout<<"G4QuaString::C: nQTarg="<<nQTarg<<", xProj="<<xT<<", rTMass="<<rTMass<<G4endl;
 #endif
   G4LorentzVector tr4Mom(0.,0.,0.,rTMass);   // Prototype of LV of the residual projectile
   if(targHadron.DecayIn2(tq4Mom,tr4Mom)) targFl=true; // Targ decay is OK
-  else G4cout<<"**Worning**G4QStr::Constr:TargDecIn2 rtM="<<rTMass<<", tM="<<tM<<G4endl;
-#ifdef pdebug
-  G4cout<<"G4QStr::Con:"<<targFl<<" split TARG in R4M="<<tr4Mom<<" & Q4M="<<tq4Mom<<G4endl;
+  else G4cout<<"**Worning**G4QuaStr::Constr:TargDecIn2 rtM="<<rTMass<<", tM="<<tM<<G4endl;
+#ifdef pdebug
+  G4cout<<"G4QuaStr::C:"<<targFl<<" split TARG in R4M="<<tr4Mom<<" & Q4M="<<tq4Mom<<G4endl;
 #endif
   G4bool elasFl=false;                       // ByDefault avoid the elastic scattering
@@ -208,13 +214,13 @@
     // @@ Just to try ---- End
 #ifdef pdebug
-    G4cout<<"G4QS::Cons: npM="<<npM<<" <? pM="<<pM<<"+mPi0="<<mPi0<<" = "<<pM+mPi0<<G4endl;
+    G4cout<<"G4QuaStr::C:npM="<<npM<<" <? pM="<<pM<<"+mPi0="<<mPi0<<" = "<<pM+mPi0<<G4endl;
 #endif
     if(npM<pM+mPi0) // The projectile is under min mass (@@ In Future put other cut @@)
     {
       G4double valk=tq4Mom.e();         // Momentum of the target quark
-						//#ifdef pdebug
+      //#ifdef pdebug
       G4double dvalk=valk-tq4Mom.rho();
-      if(fabs(dvalk)>.00001) G4cout<<"***kp***G4QS::C:vk="<<valk<<",dvk="<<dvalk<<G4endl;
-						//#endif
+      if(fabs(dvalk)>.00001) G4cout<<"**kp**G4QuaStr::C:vk="<<valk<<",dvk="<<dvalk<<G4endl;
+      //#endif
       G4double dmas=pM2-pr4Mom.m2();    // Difference of squared masses
       G4double vale=pr4Mom.e();
@@ -226,5 +232,5 @@
       {
 #ifdef pdebug
-        G4cout<<"***p***>>>G4QS::C: cost="<<cost<<G4endl;
+        G4cout<<"***p***>>>G4QuasmonString::Constr: cost="<<cost<<G4endl;
 #endif
         // Get max value of |cos(theta)| and change tq value to get the pM on mass shell
@@ -238,11 +244,11 @@
         }
         else                               // --->>> cost<0.
-								{
+        {
           G4double hvalk=dmas/(vale+valp); // Momentum's too small (must be increased, LIM)
           if(hvalk>tM)                     // Momentum can not be increased to this value
           {
 #ifdef pdebug
-            G4cout<<"**p-Cor**>G4QS::C: hvalk="<<hvalk<<" > tM="<<tM<<", dm="<<dmas<<", e="
-                  <<vale<<", p="<<valp<<", ct="<<cost<<G4endl;
+            G4cout<<"**p-Cor**>G4QuaStr::C: hvalk="<<hvalk<<" > tM="<<tM<<", dm="<<dmas
+                  <<", e="<<vale<<", p="<<valp<<", ct="<<cost<<G4endl;
 #endif
             // Put the scatteredProjectile on the massShell, and rescatter the target quark
@@ -252,10 +258,11 @@
             pq4Mom=G4LorentzVector(0.,0.,0.,0.);        // NewProjParton on lightMassShell
             tmpBl=tmpHadron.DecayIn2(newProj4M,pq4Mom); // Decay the Compound in newProg+pQ
-            if(!tmpBl)G4cout<<"G4QS::C:DecIn2 err "<<sqrt(tmpProj4M.m2())<<"<"<<pM<<G4endl;
+            if(!tmpBl)
+              G4cout<<"G4QuaStr::Con: DecIn2 err "<<sqrt(tmpProj4M.m2())<<"<"<<pM<<G4endl;
           }
           else
-										{
-#ifdef pdebug
-            G4cout<<"***---***>G4QS::C: hvalk="<<hvalk<<" < tM="<<tM<<G4endl;
+          {
+#ifdef pdebug
+            G4cout<<"***---***>G4QuasmonStr::Constr: hvalk="<<hvalk<<" < tM="<<tM<<G4endl;
 #endif
             valk=hvalk/2;                  // Momentum is too small (must be reduced)
@@ -266,5 +273,6 @@
           }
         }
-        if(fabs(newProj4M.m()-pM)>.0001)G4cout<<"G4QS::C:"<<newProj4M.m()<<","<<pM<<G4endl;
+        if(fabs(newProj4M.m()-pM)>.0001)
+          G4cout<<"*G4QuaString::Constr: Change of mass "<<newProj4M.m()<<"#"<<pM<<G4endl;
       }
       else
@@ -272,5 +280,5 @@
         // Turn the target quark-parton to the projectile residual in LS = CMSofTheTarget
 #ifdef pdebug
-        G4cout<<"---p--->>>G4QS::C: cost="<<cost<<G4endl;
+        G4cout<<"---p--->>>G4QuasmonString::Constr: cost="<<cost<<G4endl;
 #endif
         G4ThreeVector tq=tq4Mom.v();           // 3-mom of the targetQ (LS)
@@ -286,10 +294,12 @@
         tq4Mom.setV(tqf);                      // Change the momentum direction of targetQ
         tr4Mom.setV(-tqf);                     // Change the momentum direction of targetR
-        if(fabs(tqf.mag()-valk)>.0001)G4cout<<"*G4QS::C:||="<<tqf.mag()<<","<<valk<<G4endl;
+        if(fabs(tqf.mag()-valk)>.0001)
+          G4cout<<"*G4QuasmonString::Constr: |k|="<<tqf.mag()<<" # "<<valk<<G4endl;
         newProj4M=tq4Mom+pr4Mom;
-        if(fabs(newProj4M.m()-pM)>.001)G4cout<<"*G4QS::C:"<<newProj4M.m()<<","<<pM<<G4endl;
+        if(fabs(newProj4M.m()-pM)>.001)
+          G4cout<<"*G4QuasmonString::Constr: M="<<newProj4M.m()<<" # "<<pM<<G4endl;
       }
 #ifdef pdebug
-      G4cout<<"G4QStr::C: Proj under GS, newP4M="<<newProj4M<<", pq4M="<<pq4Mom<<G4endl;
+      G4cout<<"G4QuaStr::C: Proj under GS, newP4M="<<newProj4M<<", pq4M="<<pq4Mom<<G4endl;
 #endif
       pcorFl=true;                           // Projectile is on the GS mass shell
@@ -303,5 +313,5 @@
     //ntM=sqrt(nTM2);
 #ifdef pdebug
-    G4cout<<"G4QStr::C: ntM="<<ntM<<" <? tM="<<tM<<"+mPi0="<<mPi0<<" = "<<tM+mPi0<<G4endl;
+    G4cout<<"G4QuaStr::C:ntM="<<ntM<<" <? tM="<<tM<<"+mPi0="<<mPi0<<" = "<<tM+mPi0<<G4endl;
 #endif
     if(ntM<tM+mPi0 && !pcorFl) // The target is under min mass (@@ InFut put another cut@@)
@@ -311,8 +321,8 @@
       pqc4M.boost(projRBoost);             // projectileQuark => projCM system <step2>
       G4double valk=pqc4M.e();             // Momentum of the target quark in projCM
-						//#ifdef pdebug
+      //#ifdef pdebug
       G4double dvalk=valk-pqc4M.rho();
-      if(fabs(dvalk)>.00001) G4cout<<"***kt***G4QS::C:vk="<<valk<<",dvk="<<dvalk<<G4endl;
-						//#endif
+      if(fabs(dvalk)>.00001) G4cout<<"***kt***G4QuaS::C:vk="<<valk<<",dvk="<<dvalk<<G4endl;
+      //#endif
       G4double dmas=tM2-tr4Mom.m2();       // Difference of squared masses (targ - targRes)
       G4LorentzVector trc4M=tr4Mom;        // targetResidual => projCM system <step1>
@@ -321,5 +331,5 @@
       G4ThreeVector tr=trc4M.v();          // 3-mom of the targetResidual in projCM
       G4double valp=tr.mag();              // momentum of the targetResidual in projCM
-      if(fabs(dmas-tM2+trc4M.m2())>.1) G4cout<<"**t**G4QS::C: trM2="<<tr4Mom.m2()<<"="
+      if(fabs(dmas-tM2+trc4M.m2())>.1) G4cout<<"**t**G4QuaStr::C: trM2="<<tr4Mom.m2()<<"="
                                             <<trc4M.m2()<<","<<vale*vale-valp*valp<<G4endl;
       G4ThreeVector utr=tr/valp;           // Unit vector in the tr direction in projCM
@@ -328,5 +338,5 @@
       {
 #ifdef pdebug
-        G4cout<<"***t***>>>G4QS::C: cost="<<cost<<G4endl;
+        G4cout<<"***t***>>>G4QuasmonString::Constr: cost="<<cost<<G4endl;
 #endif
         // Get max value of |cos(theta)| and change pq value to get the tM on mass shell
@@ -344,11 +354,11 @@
         }
         else                                   // --->>> cost<-1 => cost=-1
-								{
+        {
           G4double hvalk=dmas/(vale+valp); // Momentum's too small (must be increased, LIM)
           if(hvalk>pM)                     // Momentum can not be increased to this value
           {
 #ifdef pdebug
-            G4cout<<"**t-Cor**>G4QS::C: hvalk="<<hvalk<<" > pM="<<pM<<", dm="<<dmas<<", e="
-                  <<vale<<", p="<<valp<<", ct="<<cost<<G4endl;
+            G4cout<<"**t-Cor**>G4QuasmonString::C: hvalk="<<hvalk<<" > pM="<<pM<<", dm="
+                  <<dmas<<", e="<<vale<<", p="<<valp<<", ct="<<cost<<G4endl;
 #endif
             // Put the scatteredProjectile on the massShell, rescatter the targetQuark (LS)
@@ -358,10 +368,11 @@
             tq4Mom=G4LorentzVector(0.,0.,0.,0.);        // NewTargParton on lightMassShell
             tmpBl=tmpHadron.DecayIn2(newTarg4M,tq4Mom); // Decay the Compound in newTarg+tQ
-            if(!tmpBl)G4cout<<"G4QS::C:DecIn2-err "<<sqrt(tmpTarg4M.m2())<<"<"<<tM<<G4endl;
+            if(!tmpBl)
+              G4cout<<"G4QuaString::C: DecIn2-err "<<sqrt(tmpTarg4M.m2())<<"<"<<tM<<G4endl;
           }
           else
-										{
-#ifdef pdebug
-            G4cout<<"***---***>G4QS::C: hvalk="<<hvalk<<" < pM="<<pM<<G4endl;
+          {
+#ifdef pdebug
+            G4cout<<"***---***>G4QuaString::Constr: hvalk="<<hvalk<<" < pM="<<pM<<G4endl;
 #endif
             valk=hvalk/2;                        // Momentum is too small (mustBeIncreased)
@@ -372,9 +383,9 @@
             G4LorentzVector nTc4M=pqc4M+trc4M;
 #ifdef pdebug
-            G4cout<<"G4QS::C:After Boost="<<projBoost<<G4endl;
-            G4cout<<"G4QS::C:Aft: q="<<pqc4M<<pqc4M.m2()<<",t="<<nTc4M<<nTc4M.m2()<<G4endl;
-            G4cout<<"G4QS::C:E="<<nTc4M.e()<<" = q="<<pqc4M.e()<<"="<<valk<<" + r="<<
-                  trc4M.e()<<"="<<vale<<" = "<<pqc4M.e()+trc4M.e()<<",c="<<pq4Mom<<G4endl;
-            if(fabs(nTc4M.m()-tM)>.0001) G4cout<<"*G4QS::C:"<<nTc4M.m()<<"!="<<tM<<G4endl;
+            G4cout<<"G4QuasmonString::Constr:After Boost="<<projBoost<<G4endl;
+            G4cout<<"G4QuS::C:Aft:q="<<pqc4M<<pqc4M.m2()<<",t="<<nTc4M<<nTc4M.m2()<<G4endl;
+            G4cout<<"G4QuaStr::C:E="<<nTc4M.e()<<" = q="<<pqc4M.e()<<"="<<valk<<" + r="<<
+                   trc4M.e()<<"="<<vale<<" = "<<pqc4M.e()+trc4M.e()<<",c="<<pq4Mom<<G4endl;
+            if(fabs(nTc4M.m()-tM)>.0001) G4cout<<"*G4QuS::C:"<<nTc4M.m()<<"!="<<tM<<G4endl;
             G4double pp=pqf.dot(tr);             // trc3M*pqc=-valk*valp
             G4double ee=vale*valk;
@@ -383,6 +394,6 @@
             G4double sen=nTc4M.e();
             G4double smo=nTc4M.rho();
-            G4cout<<"G4QS::C:qM2="<<pqc4M.m2()<<",rM2="<<trc4M.m2()<<",E="<<sen<<"="<<
-														vale+valk<<",P="<<smo<<"="<<valp-valk<<",M="<<sqrt(sen*sen-smo*smo)<<G4endl;
+            G4cout<<"G4QuaStr::C: qM2="<<pqc4M.m2()<<",rM2="<<trc4M.m2()<<",E="<<sen<<"="<<
+              vale+valk<<", P="<<smo<<"="<<valp-valk<<",M="<<sqrt(sen*sen-smo*smo)<<G4endl;
 #endif
             G4LorentzVector prc4M(pM-valk,-pqf); // Fill new 4-mom for projectResid in CM
@@ -393,5 +404,5 @@
         }
         if(fabs(newTarg4M.m()-tM)>.0001)
-          G4cout<<"******************************G4QS::C:"<<newTarg4M.m()<<"="<<pM<<G4endl;
+          G4cout<<"****************G4QuasmonString::C: M="<<newTarg4M.m()<<"="<<pM<<G4endl;
       }
       else // -1<cos(theta)<1 - only rotate the projQ
@@ -399,5 +410,5 @@
         // Turn the projectile quark-parton to the target residual in CMS of the Projectile
 #ifdef pdebug
-        G4cout<<"---t--->>>G4QS::C: cost="<<cost<<G4endl;
+        G4cout<<"---t--->>>G4QuasmonString::Constr: cost="<<cost<<G4endl;
 #endif
         G4LorentzVector prc4M=pr4Mom;          // projectileQuark => projCM system <step1>
@@ -419,14 +430,16 @@
 #ifdef pdebug
         G4LorentzVector nT4M=pqc4M+trc4M;
-        if(fabs(nT4M.m()-tM)>.001)G4cout<<"****t****G4QS::C:M="<<nT4M.m()<<"="<<tM<<G4endl;
+        if(fabs(nT4M.m()-tM)>.001)G4cout<<"**t**G4QuaStr::C:M="<<nT4M.m()<<"="<<tM<<G4endl;
 #endif
         pr4Mom=prc4M;               // <step1> // Fill new 4-mom for projResidual in LS
         pr4Mom.boost(projBoost);    // <step2> // Fill new 4-mom for projResidual in LS
-        if(fabs(pqf.mag()-valk)>.0001)G4cout<<"*G4QS::C:||="<<pqf.mag()<<"="<<valk<<G4endl;
+        if(fabs(pqf.mag()-valk)>.0001)
+          G4cout<<"*G4QuasmonString::Constr: |k|="<<pqf.mag()<<"="<<valk<<G4endl;
         newTarg4M=pq4Mom+tr4Mom;
-        if(fabs(newTarg4M.m()-tM)>.001)G4cout<<"*G4QS::C:"<<newTarg4M.m()<<"="<<tM<<G4endl;
+        if(fabs(newTarg4M.m()-tM)>.001)
+          G4cout<<"*G4QuasmonString::Constr: M="<<newTarg4M.m()<<"="<<tM<<G4endl;
       }
 #ifdef pdebug
-      G4cout<<"G4QStr::C: Targ under GS, newT4M="<<newTarg4M<<", tq4M="<<tq4Mom<<G4endl;
+      G4cout<<"*G4QuaStr::C: Targ under GS, newT4M="<<newTarg4M<<", tq4M="<<tq4Mom<<G4endl;
 #endif
       tcorFl=true;                  // Target is on the GS mass shell
@@ -435,5 +448,5 @@
       npM=sqrt(nPM2);
 #ifdef pdebug
-      G4cout<<"G4QStr::C:npM="<<npM<<" <? pM="<<pM<<"+mPi0="<<mPi0<<" = "<<pM+mPi0<<G4endl;
+      G4cout<<"G4QuaStr::C:npM="<<npM<<" <? pM="<<pM<<"+mPi0="<<mPi0<<"="<<pM+mPi0<<G4endl;
 #endif
       if(npM<pM+mPi0) elasFl=true;    // Force elastic scattering (@@InFut putAnotherCut@@)
@@ -444,5 +457,5 @@
       // **** Put the hadrons on the mass shell conserving the CMS scattering angle ****
       G4LorentzVector theTot4M=theProj4Mom+theTarg4Mom;// 4-momentum of CMS of "targ+proj"
-		    G4ThreeVector cmsBoost = theTot4M.boostVector(); // CMS Boost Vector "CMS to LS"
+      G4ThreeVector cmsBoost = theTot4M.boostVector(); // CMS Boost Vector "CMS to LS"
       G4ThreeVector cmsRBoost= -cmsBoost;              // CMS Boost Vector "LS to CMS"
       G4LorentzVector cmsProj4M=theProj4Mom; // LS projectile => CMS <step1>
@@ -454,5 +467,5 @@
       if(fabs(cmsTarg4M.rho()-pcm) > 0.0001)
         G4cout<<"-Worning-G4QuasmonString::Constr: P="<<cmsTarg4M.rho()<<"#"<<pcm<<G4endl;
-						//#endif
+      //#endif
       G4LorentzVector cmsNewPr4M=newProj4M;  // LS finalProj => CMS <step1>
       cmsNewPr4M.boost(cmsRBoost);           // LS finalProj => CMS <step2>
@@ -464,5 +477,5 @@
       if(1.+puV.dot(tuV) > 0.001)
         G4cout<<"-Worning-G4QuasmonString::Constr: ct="<<puV.dot(tuV)<<G4endl;
-						//#endif
+      //#endif
       cmsProj4M.setV(puV*pcm);
       newProj4M=cmsProj4M;
@@ -501,5 +514,5 @@
         theQHadrons.push_back(targH);        // Fill the Target Hadron (delete equivalent)
       }
-						else                                   // Both are excited (two Quasmons only) 
+      else                                   // Both are excited (two Quasmons only) 
       {
         G4Quasmon* projQ = new G4Quasmon(projHadron.GetQC(),newProj4M);
@@ -530,18 +543,18 @@
     finBaryoN+=theQuasmons[iq]->GetBaryonNumber();
   }
-  G4cout<<"G4QStr::C:nH="<<nHad<<",nQ="<<nQuas<<",C="<<finCharge<<",B="<<finBaryoN<<G4endl;
+  G4cout<<"G4QuaStr::C:n="<<nHad<<",N="<<nQuas<<",C="<<finCharge<<",B="<<finBaryoN<<G4endl;
   if(finCharge!=totCharge || finBaryoN!=totBaryNum)
   {
-    G4cerr<<"***G4QStr::C:tC="<<totCharge<<",C="<<finCharge<<",tB="<<totBaryNum
+    G4cerr<<"***G4QuasmonString::C: tC="<<totCharge<<",C="<<finCharge<<",tB="<<totBaryNum
           <<",B="<<finBaryoN<<G4endl;
     if(nHad) for(G4int h=0; h<nHad; h++)
     {
       G4QHadron* cH = theQHadrons[h];
-      G4cerr<<"::G4QS::C:h#"<<h<<",QC="<<cH->GetQC()<<",PDG="<<cH->GetPDGCode()<<G4endl;
+      G4cerr<<">G4QuaStr::C:h#"<<h<<",QC="<<cH->GetQC()<<",PDG="<<cH->GetPDGCode()<<G4endl;
     }
     if(nQuas) for(G4int q=0; q<nQuas; q++)
     {
       G4Quasmon* cQ = theQuasmons[q];
-      G4cerr<<"::G4QS::C:q#"<<q<<",C="<<cQ->GetCharge()<<",QuarkCon="<<cQ->GetQC()<<G4endl;
+      G4cerr<<">G4QuaStr::C:q#"<<q<<",C="<<cQ->GetCharge()<<",QCont="<<cQ->GetQC()<<G4endl;
     }
   }
@@ -557,5 +570,5 @@
     G4Quasmon* curQ    = new G4Quasmon(right.theQuasmons[iq]);
 #ifdef fdebug
-    G4cout<<"G4QS::CopyByVal:Q#"<<iq<<","<<curQ->GetQC()<<curQ->Get4Momentum()<<G4endl;
+    G4cout<<"G4QuaStr::CopyByVal:Q#"<<iq<<","<<curQ->GetQC()<<curQ->Get4Momentum()<<G4endl;
 #endif
     theQuasmons.push_back(curQ);             // (delete equivalent)
@@ -570,7 +583,7 @@
   
   theWorld        =  right.theWorld; 
-		tot4Mom         =	 right.tot4Mom;
-		totCharge       =	 right.totCharge;
-		totBaryNum      =	 right.totBaryNum;
+  tot4Mom         =  right.tot4Mom;
+  totCharge       =  right.totCharge;
+  totBaryNum      =  right.totBaryNum;
 }
 
@@ -588,5 +601,5 @@
       G4Quasmon* curQ    = new G4Quasmon(right.theQuasmons[iq]);
 #ifdef fdebug
-      G4cout<<"G4QS::CopyByVal:Q#"<<iq<<","<<curQ->GetQC()<<curQ->Get4Momentum()<<G4endl;
+      G4cout<<"G4QuaStr::CpByVal:Q#"<<iq<<","<<curQ->GetQC()<<curQ->Get4Momentum()<<G4endl;
 #endif
       theQuasmons.push_back(curQ);             // (delete equivalent)
@@ -601,7 +614,7 @@
   
     theWorld        =  right.theWorld; 
-		  tot4Mom         =	 right.tot4Mom;
-		  totCharge       =	 right.totCharge;
-		  totBaryNum      =	 right.totBaryNum;
+    tot4Mom         =  right.tot4Mom;
+    totCharge       =  right.totCharge;
+    totBaryNum      =  right.totBaryNum;
   }
   return *this;
@@ -616,5 +629,5 @@
     G4Quasmon* curQ    = new G4Quasmon(right->theQuasmons[iq]);
 #ifdef fdebug
-    G4cout<<"G4QS::CopyByPoint:Q#"<<iq<<","<<curQ->GetQC()<<curQ->Get4Momentum()<<G4endl;
+    G4cout<<"G4QuaStr::CpByPoint:Q#"<<iq<<","<<curQ->GetQC()<<curQ->Get4Momentum()<<G4endl;
 #endif
     theQuasmons.push_back(curQ);             // (delete equivalent)
@@ -629,7 +642,7 @@
   
   theWorld        =  right->theWorld; 
-		tot4Mom         =	 right->tot4Mom;
-		totCharge       =	 right->totCharge;
-		totBaryNum      =	 right->totBaryNum;
+  tot4Mom         =  right->tot4Mom;
+  totCharge       =  right->totCharge;
+  totBaryNum      =  right->totBaryNum;
 }
 
@@ -664,5 +677,5 @@
 G4QHadronVector* G4QuasmonString::Fragment()
 {//              ========================== -- @@ Must be changed @@ --
-		// Make the final check before filling the output -- @@ Must be changed @@ --
+  // Make the final check before filling the output -- @@ Must be changed @@ --
 #ifdef chdebug
   G4int fCharge=0;
@@ -682,15 +695,15 @@
   if(fCharge!=totCharge || fBaryoN!=totBaryNum)
   {
-    G4cerr<<"***G4QS::Frag:tC="<<totCharge<<",C="<<fCharge<<",tB="<<totBaryNum
-          <<",B="<<fBaryoN<<G4endl;
+    G4cerr<<"***G4QuasmonString::Fragment: tC="<<totCharge<<", C="<<fCharge<<", tB="
+          <<totBaryNum<<", B="<<fBaryoN<<G4endl;
     if(nHad) for(G4int h=0; h<nHad; h++)
     {
       G4QHadron* cH = theQHadrons[h];
-      G4cerr<<":G4QS::HQ:h#"<<h<<",QC="<<cH->GetQC()<<",PDG="<<cH->GetPDGCode()<<G4endl;
+      G4cerr<<":G4QuaSt::HQ:h#"<<h<<",QC="<<cH->GetQC()<<",PDG="<<cH->GetPDGCode()<<G4endl;
     }
     if(nQuas) for(G4int q=0; q<nQuas; q++)
     {
       G4Quasmon* cQ = theQuasmons[q];
-      G4cerr<<":G4QS::HQ:q#"<<q<<",C="<<cQ->GetCharge()<<",QCont="<<cQ->GetQC()<<G4endl;
+      G4cerr<<":G4QuaSt::HQ:q#"<<q<<",C="<<cQ->GetCharge()<<",QCont="<<cQ->GetQC()<<G4endl;
     }
   }
@@ -781,5 +794,5 @@
   // @@ TMP --- Begin ---
   if(2>1)
-		{
+  {
     if(nPart<2)
     {
@@ -792,6 +805,6 @@
     if(r==0.) return 0.;
     if(r==1.) return 1.;
-		  if     (nPart==3) x=r;          // GS baryon
-		  else if(nPart==4) x=1.-sqrt(r); // GS quaternion
+    if     (nPart==3) x=r;          // GS baryon
+    else if(nPart==4) x=1.-sqrt(r); // GS quaternion
     else x=1.-pow(r,1./(nPart-2.)); // nPart>4
     return x;
@@ -809,7 +822,7 @@
   if(r==0.) return 0.;
   if(r==1.) return 1.;
-		if(nPart==3) x=sqrt(r);      // GS baryon
-		else if(nPart==4)            // GS quaternion
-		{
+  if(nPart==3) x=sqrt(r);      // GS baryon
+  else if(nPart==4)            // GS quaternion
+  {
     if    (r==0.5) x=0.5;
     else if(r<0.5) x=sqrt(r+r)*(.5+.1579*(r-.5));
@@ -817,5 +830,5 @@
   }
   else
-		{
+  {
     G4int n1=nPart-2;
     G4double r1=n1;
@@ -826,13 +839,13 @@
     if  (r==rr)  x=p2;
     else
-				{
+    {
       if(r<rr)
       {
-								G4double pr=0.;
-								G4double pra=0.;
+        G4double pr=0.;
+        G4double pra=0.;
         if(nPart>8)
-								{
+        {
           if(nPart>10)
-								  {
+          {
             if(nPart>11)                      // >11
             {
@@ -840,5 +853,5 @@
               pra=.915/pow((nPart+6.7),1.75);
             }
-												else                              // 11
+            else                              // 11
             {
               pr=.09945;
@@ -847,5 +860,5 @@
           }
           else
-								  {
+          {
             if(nPart>9)                       // 10
             {
@@ -853,5 +866,5 @@
               pra=.00741;
             }
-												else                              // 9
+            else                              // 9
             {
               pr=.11425;
@@ -861,7 +874,7 @@
         }
         else
-								{
+        {
           if(nPart>6)
-								  {
+          {
             if(nPart>7)                       // 8
             {
@@ -869,5 +882,5 @@
               pra=.00926;
             }
-												else                              // 7
+            else                              // 7
             {
               pr=.13405;
@@ -876,5 +889,5 @@
           }
           else
-								  {
+          {
             if(nPart>5)                       // 6
             {
@@ -882,5 +895,5 @@
               pra=.01112;
             }
-												else                              // 5
+            else                              // 5
             {
               pr=.15765;
@@ -893,29 +906,29 @@
       else
       {
-								G4double sr=0.;
+        G4double sr=0.;
         if(nPart>8)
-								{
+        {
           if(nPart>10)
-								  {
+          {
             if(nPart>11) sr=.86/(nPart+1.05); // >11
-												else         sr=.0774;            // 11
+            else         sr=.0774;            // 11
           }
           else
-								  {
+          {
             if(nPart>9) sr=.0849;             // 10
-												else        sr=.0938;             // 9
+            else        sr=.0938;             // 9
           }
         }
         else
-								{
+        {
           if(nPart>6)
-								  {
+          {
             if(nPart>7) sr=.1047;             // 8
-												else        sr=.1179;             // 7
+            else        sr=.1179;             // 7
           }
           else
-								  {
+          {
             if(nPart>5) sr=.1339;             // 6
-												else        sr=.15135;            // 5
+            else        sr=.15135;            // 5
           }
         }
@@ -940,6 +953,6 @@
   if(r==0.) return 0.;
   if(r==1.) return 1.;
-		if     (nPart==3) x=r;          // GS baryon
-		else if(nPart==4) x=1.-sqrt(r); // GS quaternion
+  if     (nPart==3) x=r;          // GS baryon
+  else if(nPart==4) x=1.-sqrt(r); // GS quaternion
   else x=1.-pow(r,1./(nPart-2.)); // nPart>4
   return x;
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/History
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/History	(revision 1055)
@@ -12,4 +12,16 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+
+23-Jan-2009 M.Kosov (hadr-chips-inter-V09-02-06)
+------------------------------------------------------
+- Change of GetNuclearMass(A-1.,Z-1.) (and similar) to GetNuclearMass(A-1,Z-1)
+  To be consistent with the new Hisaya's developments. The changes are made in
+  the G4Q(Photon,Electron,Muon,Tau)NuclearCrossSection classes
+
+23-Jan-2009 V.Ivanchenko (hadr-chips-inter-V09-02-00)
+------------------------------------------------------
+- added deregistration in destructor of G4QCaptureAtRest
+- added string decay destruction to G4ElectroNuclearReaction
 
 24-Oct-2008 Dennis Wright (hadr-chips-inter-V09-01-09)
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/include/G4ChiralInvariantPhaseSpace.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/include/G4ChiralInvariantPhaseSpace.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/include/G4ChiralInvariantPhaseSpace.hh	(revision 1055)
@@ -28,6 +28,6 @@
 
 //
-// Modified:
-// 16.01.08 V.Ivanchenko move inlined method to source
+// Created: H.-P. Wellicsh: GHAD model wrapper for the CHIPS model (1997)
+// Modified: 16.01.08 V.Ivanchenko move inlined method to source
 //
 
